<template>
  <div class="container my-5">
    <h1 class="h2 mb-4">Order</h1>
    <b-form class="mb-5">
      <b-card bg-variant="light">
      <b-form-group
        label-cols-lg="3"
        label="Your shipping Address"
        label-class="text-primary font-weight-bold pt-0"
      >
      <b-row>
        <b-col>
          <b-form-group
            id="input-group-1"
            label="Firstname"
            label-for="input-1"
            label-size="sm"
            label-class="text-muted mb-0"
          >
            <b-form-input id="input-1" v-model="ouser.name.firstname" required></b-form-input>
          </b-form-group>
        </b-col>
        <b-col>
          <b-form-group
            id="input-group-2"
            label="Lastname"
            label-for="input-2"
            label-size="sm"
            label-class="text-muted mb-0"
          >
            <b-form-input id="input-2" v-model="ouser.name.lastname" required></b-form-input>
          </b-form-group>
        </b-col>
      </b-row>
      <b-row>
        <b-col>
          <b-form-group
            id="input-group-3"
            label="Number"
            label-for="input-3"
            label-size="sm"
            label-class="text-muted mb-0"
          >
            <b-form-input id="input-3" v-model="ouser.address.number" required></b-form-input>
          </b-form-group>
        </b-col>
        <b-col>
          <b-form-group
            id="input-group-4"
            label="Street"
            label-for="input-4"
            label-size="sm"
            label-class="text-muted mb-0"
          >
            <b-form-input id="input-4" v-model="ouser.address.street" required></b-form-input>
          </b-form-group>
        </b-col>
      </b-row>
      <b-row>
        <b-col>
          <b-form-group
            id="input-group-5"
            label="Zip Code"
            label-for="input-5"
            label-size="sm"
            label-class="text-muted mb-0"
          >
            <b-form-input id="input-5" v-model="ouser.address.zipcode" required></b-form-input>
          </b-form-group>
        </b-col>
        <b-col>
          <b-form-group
            id="input-group-6"
            label="City"
            label-for="input-6"
            label-size="sm"
            label-class="text-muted mb-0"
          >
            <b-form-input id="input-6" v-model="ouser.address.city" required></b-form-input>
          </b-form-group>
        </b-col>
      </b-row>
      </b-form-group>
      </b-card>
      <b-card bg-variant="light" class="mt-3">
        <b-row>
          <b-col cols="12" class="col-lg-3">
            <span class="text-primary font-weight-bold pt-0 mb-3">Your cart</span>
          </b-col>
          <b-col>
            <b-table small :items="cart" :fields="fields" thead-class="font-weight-light">
              <template #cell(product)="row">
                <span>{{ getProduct(row.item.productId).title }}</span>
              </template>
              <template #cell(price)="row">
                <span>${{ getProduct(row.item.productId).price }}</span>
              </template>
            </b-table>
          </b-col>
        </b-row>
      </b-card>
    </b-form>
  </div>
</template>

<script>
import { mapState } from 'vuex'
import { mapFields } from 'vuex-map-fields'

export default {
  name: 'Order',
  data () {
    return {
      fields: [
        {
          key: 'product',
          label: 'Product'
        },
        {
          key: 'price',
          label: 'Price'
        },
        {
          key: 'quantity',
          label: 'Quantity'
        }
      ]
    }
  },
  computed: {
    ...mapFields([
      'user',
      'cart'
    ]),
    ...mapState([
      'products'
    ]),
    ouser () {
      return JSON.parse(JSON.stringify(this.user))
    },
    subtotal () {
      let price = 0
      this.cart.forEach(item => {
        const product = this.products.find(p => p.id === item.productId)
        price = price + (product.price * item.quantity)
      })
      return price
    },
    delivery () {
      let delivery = 9.95
      if (this.subtotal > 60) delivery = 0
      return delivery
    },
    total () {
      return this.subtotal + this.delivery
    }
  },
  methods: {
    getProduct (id) {
      return this.products.find(p => p.id === id)
    }
  }
}
</script>
